<template>
  <div :id="id" class="image-popup-content">
    <div class="te-tab-section">
      <div class="te-tab">
        <button
          v-for="tab in tabs"
          :key="tab.key"
          type="button"
          :class="{ 'te-tab-active': activeTab === tab.key }"
          @click="onClickTab(tab.key)"
        >
          {{ tab.label }}
        </button>
      </div>
    </div>
    <div :class="{ 'te-url-type': true, 'te-tab-active': activeTab === 'url' }">
      <label :for="`${id}_url`">Image URL</label>
      <input type="text" :id="`${id}_url`" :class="{ 'te-image-url-input': true, wrong: hasUrlError }" v-model="url" />
    </div>
    <div :class="{ 'te-file-type': true, 'te-tab-active': activeTab === 'files' }">
      <label :for="`${id}_files`">Select image file(s)</label>
      <input
        type="file"
        ref="fileInputRef"
        :id="`${id}_files`"
        :class="{ 'te-image-file-input': true, wrong: hasFilesError }"
        accept="image/*"
        multiple
      />
    </div>
    <div
      :class="{
        'te-gallery-type': true,
        'te-tab-active': activeTab === 'gallery',
      }"
    >
      Loading...
    </div>
    <div v-if="showDescription">
      <label :for="`${id}_description`">Description</label>
      <input type="text" :id="`${id}_description`" class="te-alt-text-input" v-model="description" />
    </div>
    <div class="te-button-section">
      <button type="button" class="te-ok-button" @click="onClickOk" :disabled="busy">
        <span v-if="busy" class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span>
        <span v-else>OK</span>
      </button>
      <button type="button" class="te-close-button" @click="onClickCancel">Cancel</button>
    </div>
  </div>
</template>

<script>
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// TODO Implement control registration
// import ImagesApi from '../gallery/src/api/images-api'
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

import { ref, computed, onMounted } from 'vue'

// We're recreating the Toast UI image popup rather than just adding to it, because theit image uploader inserts
// base-64 encoded images. We want to upload to our gallery and support multiple file uploads.
export default {
  name: 'ImagePopupContent',
  emits: ['imageSelector', 'insert', 'close'],
  props: {
    id: { type: String, required: true },
  },
  setup(_, context) {
    const fileInputRef = ref(null)

    const url = ref('')
    const description = ref('')
    const activeTab = ref('files')
    const tabs = ref([
      { key: 'files', label: 'Files' },
      { key: 'url', label: 'Url' },
      { key: 'gallery', label: 'Select from your gallery...' },
    ])
    const busy = ref(false)

    const showDescription = computed(() => {
      return fileInputRef.value ? fileInputRef.value.length <= 1 : true
    })

    const urlRequired = computed(() => {
      return activeTab.value === 'url'
    })

    const filesRequired = computed(() => {
      return activeTab.value === 'files'
    })

    const hasUrlError = computed(() => {
      return false
      // return this.vErrors.has('url')
    })

    const hasFilesError = computed(() => {
      return false
      // return this.vErrors.has('files')
    })

    const onClickTab = (key) => {
      activeTab.value = key
      reset()
      if (key === 'gallery') {
        context.emit('imageSelector')
      }
    }

    const onClickOk = async () => {
      /*
      const vm = this
      this.$validator.validate().then(async (result) => {
        if (result) {
          switch (this.activeTab) {
            case 'files':
              this.busy = true
              await vm.uploadImagesAsync()
              this.busy = false
              break

            case 'url':
              vm.$emit('insert', { url: vm.url, caption: vm.caption })
              break
          }

          vm.reset()
        }
      })
      */
    }

    /*
    async function uploadImagesAsync() {
      const vm = this
      const responses = []
      for (let i = 0; i < vm.files.length; i++) {
        try {
          // const response = await this.imagesApi.quickUploadAsync(vm.files[i])
          // responses.push(response)
        } catch (ex) {
          responses.push(ex)
        }
      }

      const successfulResponses = responses.filter((x) => x && x.status >= 200 && x.status <= 299)
      successfulResponses.forEach((response) => {
        vm.$emit('insert', response.data) // Assuming response.data is an image object
      })

      const successful = successfulResponses.length
      const attempted = responses.length

      if (attempted === 0) {
        this.notify.warning('No images were selected.')
      } else if (successful === 0) {
        this.notify.error(attempted === 1 ? 'Image upload failed.' : `All ${attempted} image uploads failed.`)
      } else if (successful !== attempted) {
        const s = attempted === 1 ? '' : 's'
        this.notify.warning(`Only uploaded ${successful} of ${attempted} image${s}.`)
      } else {
        this.notify.success(`Successfully uploaded ${StringHelper.noun(successful, 'image', 'images')}.`)

        this.$emit('close')
      }
    }
    */

    const onClickCancel = () => {
      context.emit('close')
    }

    const reset = () => {
      url.value = ''
      fileInputRef.value = ''
      description.value = ''
      busy.value = false
      // this.$validator.reset()
    }

    onMounted(() => {
      reset()
    })

    // imagesApi = new ImagesApi(api, auth)
    // v-validate="{ required: this.urlRequired }"
    // data-vv-name="files"
    // data-vv-name="url"

    return {
      fileInputRef,
      url,
      description,
      activeTab,
      tabs,
      busy,
      showDescription,
      urlRequired,
      filesRequired,
      hasUrlError,
      hasFilesError,
      onClickTab,
      onClickOk,
      onClickCancel,
    }
  },
}
</script>

<style lang="scss">
@use '../../../sass/vars';

/* The CSS is kind of retarded, but we're keeping it consistent with Toast UI Editor, so that their styling works. */
.te-url-type,
.te-file-type,
.te-gallery-type {
  display: none;
}

:not(.te-tab) > .te-tab-active {
  display: block;
}

.te-ok-button {
  margin-right: 0.25em;
}
</style>
